/* 
  Course:	CSE142-AG
  Homework:	#4
  Title:	Rain Gods and Goddesses 
  Name:		Fareeda Khojandi
  I.D.:		9726943
  TA:		Vivek Saharanaman
  Date:		11-16-98

*/
	
 

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>		/* <time.h> is here only so that one function can be called
						to seed the random number generator. */
						
								
#define TRUE    	1
#define FALSE   	0

						
#define BUTTON_HEIGHT  	35		/* Configure the appearance of the buttons on the menu bar 
								number of pixels of button height and width*/
#define BUTTON_WIDTH 	100

							
#define NUM_BUTTONS 	7		/*change this if you add or delete buttons*/


#define SELECTED_COLOR   YELLOW		/*color of letter on buttons*/ 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	500		/*This is the total number of drops possible 
									at one time.*/
	

#define TOP_OF_SEA (- 2 * (GP142_YMAX / 5))		/* y-ccordinate of the top of 
												the "dirt" in the landscape*/

#define FILL 0				/* For many of the GP142 functions, a line width of
							zero means to fill the shape being drawn. */
 
#define NONE 0				/* Types of precipitations we support */
#define RAIN 1
#define SNOW 2
#define HAIL 3


#define MAX_PRECIP_TYPES 3		/*if you add new types of percip, you may 
								need to change this*/


#define BUTTON 1				/*Possible places for mouse clicks*/
	
#define SEA 2				/*The above means you clicked 
							on SOME button (doesn't say which one yet)*/
							/*The above means you clicked in the dirt area */


/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/
void ClearAllPrecipitation(int precip_type[]);


/*render (draw) all the precipitation*/ 
void DrawAllPrecipitation(int precip_type, int x, int y, int color);

void DrawLandscape();

/*draw one drop*/
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant);

/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y,i;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;

  int boat_x = GP142_XMAX - 160;
  int boat_y = -GP142_YMAX + 40;
  
  int ship_x = GP142_XMAX - 250;
  int ship_y = -GP142_YMAX + 110;
  
  /* 
   * The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
 

  int precip_type[500];
  int bottom_x[500];
  int bottom_y[500];
  int precip_color[500];
  int count = 0;
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;

  /*what kind of click was there?*/
  int mouse_click;

  int event; /*the most recent GP142 event*/

  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */

      
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape();
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 
/*  ClearAllPrecipitation (&precip_type);


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag);
 
		if (clear_flag)
			ClearAllPrecipitation(precip_type);
		 
	} else if ((mouse_click != SEA)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)){
			/* At this point you have everything you need to know about a drop.
			What are you going to do with the information? */
		

		precip_type[count] = current_precip;
		bottom_x[count] = mouse_x;
		bottom_y[count] = mouse_y;
		precip_color[count] = current_color;
		count++;

		
	}
	
	
      
      break;

    case GP142_PERIODIC:
      	/*Some time has passed, 
		so make all the precipitation a little lower*/
        for (i = 0; i < count; i++)
		{ bottom_y[i] = bottom_y[i] - 3;
		  if (bottom_y[i] < -GP142_XMAX -30) 
		  {   bottom_y[i] = - bottom_y[i];
			  bottom_x[i] = bottom_x[i] - 1;
		  }
		}


		/*and change the sun's position a little bit*/
		sun_x = sun_x - 1;
		if (sun_x < -GP142_XMAX -30) 
		{	sun_x = - sun_x;
			sun_y = sun_y -1;
				/* over a long period of time, the sun will set.*/
		}
		
		/* change ship's position */

		ship_x = ship_x - 2;
		if (ship_x < -GP142_XMAX - 185)
		{	ship_x = - ship_x;
			ship_y = ship_y - 1;
		}

		/* change the boats' position */

		boat_x = boat_x - 12;
		if (boat_x < -GP142_XMAX - 210)
		{	boat_x = - boat_x;
			boat_y = boat_y - 1;
		}

		

      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y, boat_x, boat_y, ship_x, ship_y);
    DrawButtons(current_precip, current_color);
	for(i = 0;i < count; i++)
	{  DrawAllPrecipitation(precip_type[i], bottom_x[i], bottom_y[i], precip_color[i]);

	}  /* end event loop */
	
  }
  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.
	*/
void ClearAllPrecipitation (int precip_type[]) {
int i;
 for (i = 0; i < 500; i++) 
  precip_type[i] = NONE;
}



#define RAINDROP_WIDTH 3
	
void DrawRainDrop (int x, int y, int color) { 

	GP142_circleXY(color, x, y, RAINDROP_WIDTH); 
	
}


void DrawSnowDrop (int x, int y, int color) {


	GP142_lineXY(color, x, y, x + 3, y + 3, 2);
	GP142_lineXY(color, x, y, x - 3, y - 3, 2);
	GP142_lineXY(color, x, y, x + 3, y - 3, 2);
	GP142_lineXY(color, x, y, x - 3, y + 3, 2);
	GP142_lineXY(color, x, y, x + 5, y, 1);
	GP142_lineXY(color, x, y, x - 5, y, 1);
	
	
}

#define HAILDROP_WIDTH 4
#define HAILDROP_HEIGHT 5

void DrawHailDrop(int x, int y, int color) {

	GP142_rectangleXY(color, x , y, HAILDROP_WIDTH + x, HAILDROP_HEIGHT + y, FILL);

}

void DrawAllPrecipitation(int precip_type, int x, int y, int color)
{

	if (y >= TOP_OF_SEA - 20) {
		switch (precip_type) {
		case RAIN:
			DrawRainDrop (x, y, color);
			break;
		case SNOW:
			DrawSnowDrop (x, y, color);
			break;
		case HAIL:
			DrawHailDrop (x, y, color);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
			
		}
}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_SEA)
    return SEA;
  else
    return NONE;

}


void DrawLandscape(int sun_x, int sun_y, int boat_x, int boat_y, int ship_x, int ship_y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;


  /* Draw the sky first */
  GP142_rectangleXY(CYAN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);

  
 /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);


  /* Draw the clouds */

  GP142_lineXY(WHITE, -(3* GP142_XMAX)/4 + 60, (2 * GP142_YMAX)/3 + 30 ,
				-(3* GP142_XMAX)/4 + 150, (2 * GP142_YMAX)/3 + 30, 30);
  GP142_circleXY(WHITE, -(3* GP142_XMAX)/4 + 90, (2 * GP142_YMAX)/3 + 25, 30);
  GP142_circleXY(WHITE, -(3* GP142_XMAX)/4 + 120, (2 * GP142_YMAX)/3 + 25, 30);

  GP142_lineXY(WHITE, GP142_XMAX - 160, GP142_YMAX - 20, 
				GP142_XMAX - 100, GP142_YMAX - 20, 25);
  GP142_circleXY(WHITE, GP142_XMAX - 140, GP142_YMAX - 18, 22);
  GP142_circleXY(WHITE, GP142_XMAX - 120, GP142_YMAX - 18, 22);



  /* Draw the sea */
  /* The sea is a % of the height of the screen */
  GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_SEA, FILL);


  /* Draw the boat */

  GP142_circleXY(WHITE, boat_x , boat_y + 5, 12);

  GP142_circleXY(BLUE, boat_x + 5, boat_y + 5, 12);

  GP142_circleXY(WHITE, boat_x + 13 , boat_y + 5, 10);

  GP142_circleXY(BLUE, boat_x + 16, boat_y + 5, 10);

  GP142_circleXY(WHITE, boat_x + 20 , boat_y, 10);

  GP142_circleXY(BLUE, boat_x + 23, boat_y, 10);


  GP142_ovalXY(MAGENTA, boat_x, boat_y,
				(boat_x + 110), (boat_y + 50), FILL);

  GP142_lineXY(BLUE, boat_x, boat_y,
				(boat_x + 110), boat_y , 14);

  GP142_lineXY(WHITE, boat_x + 100, boat_y + 5, 
				boat_x + 190, boat_y - 5, 1);

   GP142_lineXY(WHITE, boat_x + 110, boat_y + 8, 
				boat_x + 190, boat_y + 10, 1); 

   GP142_lineXY(WHITE, boat_x + 110, boat_y + 10, 
				boat_x + 190, boat_y + 15, 1); 

  GP142_ovalXY(BLUE, boat_x, (boat_y + 20),
				(boat_x + 110), (boat_y + 50), FILL);

  GP142_lineXY(BLACK, (boat_x + 60), (boat_y + 20),
				(boat_x + 60), (boat_y + 60), 6);

  GP142_triangleXY(WHITE, (boat_x + 60), (boat_y + 20),
					(boat_x + 60), (boat_y + 60), 
					(boat_x + 15), (boat_y + 25), FILL);

  GP142_triangleXY(BLACK, boat_x + 190, boat_y + 10,
					boat_x + 210, boat_y + 10,
					boat_x + 210, boat_y + 30, FILL);

  GP142_triangleXY(BLACK, boat_x + 220, boat_y,
					boat_x + 240, boat_y,
					boat_x + 240, boat_y + 20, FILL);

  GP142_triangleXY(BLACK, boat_x + 160, boat_y - 10,
					boat_x + 180, boat_y - 10,
					boat_x + 180, boat_y + 10, FILL);


  

  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");


  GP142_lineXY(BLACK, boat_x, boat_y + 15 ,
				(boat_x + 105), boat_y + 15, 2);

 

  
  /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
				-GP142_XMAX, TOP_OF_SEA,
				GP142_XMAX, TOP_OF_SEA,
				0, (4 * GP142_YMAX)/5 ,
				 FILL);
  GP142_triangleXY(MED_GRAY,
				0, (4 * GP142_YMAX)/5 - 50,
				50, (4 * GP142_YMAX)/5 - 50,
				25, (4 * GP142_YMAX)/5 + 10,
				FILL);
  GP142_rectangleXY(MED_GRAY,
					-40, (4 * GP142_YMAX)/5 - 50,
					0, (4 * GP142_YMAX)/5,
					FILL);
  GP142_lineXY(MED_GRAY,
					GP142_XMAX - 50, TOP_OF_SEA + 50,
					85, (3 * GP142_YMAX)/5 - 40,
					40);
  

  GP142_triangleXY(BROWN,
		   -( 5 * GP142_XMAX/4), TOP_OF_SEA,
		   (GP142_XMAX)/3  , TOP_OF_SEA,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);
  GP142_lineXY(CYAN, 
				-(3* GP142_XMAX)/4 - 10, (2 * GP142_YMAX)/3 - 20,
				-(3* GP142_XMAX)/4 + 10, (2 * GP142_YMAX)/3 - 20, 40);
  GP142_triangleXY(BROWN, 
				-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 - 100,
				-(3* GP142_XMAX)/4 + 90, (2 * GP142_YMAX)/3 - 100,
				-(3* GP142_XMAX)/4 + 10, (2 * GP142_YMAX)/3 + 10,
				FILL);
				
  GP142_triangleXY(BROWN,
		   -GP142_XMAX / 3 , TOP_OF_SEA,
		   GP142_XMAX, TOP_OF_SEA,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);
  
  GP142_triangleXY(FOREST_GREEN,
		   (-GP142_XMAX / 3) + 5, TOP_OF_SEA,
		   GP142_XMAX + 10, TOP_OF_SEA,
		   GP142_XMAX + 10, (2 * GP142_YMAX)/3 ,
		   FILL);

/* Draw trees up the mountain */

#define TREE_BASE (-GP142_XMAX / 3) 


  GP142_lineXY(FOREST_GREEN, TREE_BASE, TOP_OF_SEA,
				TREE_BASE, TOP_OF_SEA + 15, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE, TOP_OF_SEA + 4,
			TREE_BASE + 3, TOP_OF_SEA + 11, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE, TOP_OF_SEA + 2,
				TREE_BASE - 3, TOP_OF_SEA + 11, 3); 


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 10, TOP_OF_SEA + 5,
				TREE_BASE + 10, TOP_OF_SEA + 20, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 10, TOP_OF_SEA + 9,
				TREE_BASE + 13, TOP_OF_SEA + 16, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 10 , TOP_OF_SEA + 7,
				TREE_BASE + 7, TOP_OF_SEA + 16, 3);

  
  GP142_lineXY(FOREST_GREEN, TREE_BASE + 20, TOP_OF_SEA + 10,
				TREE_BASE + 20, TOP_OF_SEA + 25, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 20, TOP_OF_SEA + 14,
				TREE_BASE + 23, TOP_OF_SEA + 21, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 20 , TOP_OF_SEA + 12,
				TREE_BASE + 17, TOP_OF_SEA + 21, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 30, TOP_OF_SEA + 15,
				TREE_BASE + 30, TOP_OF_SEA + 30, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 30, TOP_OF_SEA + 19,
				TREE_BASE + 33, TOP_OF_SEA + 26, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 30 , TOP_OF_SEA + 17,
				TREE_BASE + 27, TOP_OF_SEA + 26, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 40, TOP_OF_SEA + 20,
				TREE_BASE + 40, TOP_OF_SEA + 35, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 40, TOP_OF_SEA + 24,
				TREE_BASE + 43, TOP_OF_SEA + 31, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 40 , TOP_OF_SEA + 22,
				TREE_BASE + 37, TOP_OF_SEA + 31, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 50, TOP_OF_SEA + 28,
				TREE_BASE + 50, TOP_OF_SEA + 43, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 50, TOP_OF_SEA + 32,
				TREE_BASE + 53, TOP_OF_SEA + 39, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 50 , TOP_OF_SEA + 30,
				TREE_BASE + 47, TOP_OF_SEA + 39, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 60, TOP_OF_SEA + 33,
				TREE_BASE + 60, TOP_OF_SEA + 48, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 60, TOP_OF_SEA + 37,
				TREE_BASE + 63, TOP_OF_SEA + 44, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 60 , TOP_OF_SEA + 35,
				TREE_BASE + 57, TOP_OF_SEA + 44, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 70, TOP_OF_SEA + 38,
				TREE_BASE + 70, TOP_OF_SEA + 53, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 70, TOP_OF_SEA + 42,
				TREE_BASE + 73, TOP_OF_SEA + 49, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 70 , TOP_OF_SEA + 40,
				TREE_BASE + 67, TOP_OF_SEA + 49, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 80, TOP_OF_SEA + 43,
				TREE_BASE + 80, TOP_OF_SEA + 58, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 80, TOP_OF_SEA + 47,
				TREE_BASE + 83, TOP_OF_SEA + 54, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 80 , TOP_OF_SEA + 45,
				TREE_BASE + 77, TOP_OF_SEA + 54, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 90, TOP_OF_SEA + 53,
				TREE_BASE + 90, TOP_OF_SEA + 68, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 90, TOP_OF_SEA + 57,
				TREE_BASE + 93, TOP_OF_SEA + 64, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 90 , TOP_OF_SEA + 55,
				TREE_BASE + 87, TOP_OF_SEA + 64, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 100, TOP_OF_SEA + 58,
				TREE_BASE + 100, TOP_OF_SEA + 73, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 100, TOP_OF_SEA + 62,
				TREE_BASE + 103, TOP_OF_SEA + 69, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 100 , TOP_OF_SEA + 60,
				TREE_BASE + 97, TOP_OF_SEA + 69, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 110, TOP_OF_SEA + 63,
				TREE_BASE + 110, TOP_OF_SEA + 78, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 110, TOP_OF_SEA + 67,
				TREE_BASE + 113, TOP_OF_SEA + 74, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 110 , TOP_OF_SEA + 65,
				TREE_BASE + 107, TOP_OF_SEA + 74, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 120, TOP_OF_SEA + 73,
				TREE_BASE + 120, TOP_OF_SEA + 88, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 120, TOP_OF_SEA + 77,
				TREE_BASE + 123, TOP_OF_SEA + 84, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 120 , TOP_OF_SEA + 75,
				TREE_BASE + 117, TOP_OF_SEA + 84, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 130, TOP_OF_SEA + 78,
				TREE_BASE + 130, TOP_OF_SEA + 93, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 130, TOP_OF_SEA + 82,
				TREE_BASE + 133, TOP_OF_SEA + 89, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 130 , TOP_OF_SEA + 80,
				TREE_BASE + 127, TOP_OF_SEA + 89, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 140, TOP_OF_SEA + 83,
				TREE_BASE + 140, TOP_OF_SEA + 98, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 140, TOP_OF_SEA + 87,
				TREE_BASE + 143, TOP_OF_SEA + 94, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 140 , TOP_OF_SEA + 85,
				TREE_BASE + 137, TOP_OF_SEA + 94, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 150, TOP_OF_SEA + 93,
				TREE_BASE + 150, TOP_OF_SEA + 108, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 150, TOP_OF_SEA + 97,
				TREE_BASE + 153, TOP_OF_SEA + 104, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 150 , TOP_OF_SEA + 95,
				TREE_BASE + 147, TOP_OF_SEA + 104, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 160, TOP_OF_SEA + 98,
				TREE_BASE + 160, TOP_OF_SEA + 113, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 160, TOP_OF_SEA + 102,
				TREE_BASE + 163, TOP_OF_SEA + 109, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 160 , TOP_OF_SEA + 100,
				TREE_BASE + 157, TOP_OF_SEA + 109, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 170, TOP_OF_SEA + 108,
				TREE_BASE + 170, TOP_OF_SEA + 123, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 170, TOP_OF_SEA + 112,
				TREE_BASE + 173, TOP_OF_SEA + 119, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 170 , TOP_OF_SEA + 110,
				TREE_BASE + 167, TOP_OF_SEA + 119, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 180, TOP_OF_SEA + 113,
				TREE_BASE + 180, TOP_OF_SEA + 128, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 180, TOP_OF_SEA + 117,
				TREE_BASE + 183, TOP_OF_SEA + 124, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 180 , TOP_OF_SEA + 115,
				TREE_BASE + 177, TOP_OF_SEA + 124, 3);



  GP142_lineXY(FOREST_GREEN, TREE_BASE + 190, TOP_OF_SEA + 123,
				TREE_BASE + 190, TOP_OF_SEA + 138, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 190, TOP_OF_SEA + 127,
				TREE_BASE + 193, TOP_OF_SEA + 134, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 190 , TOP_OF_SEA + 125,
				TREE_BASE + 187, TOP_OF_SEA + 134, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 200, TOP_OF_SEA + 128,
				TREE_BASE + 200, TOP_OF_SEA + 143, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 200, TOP_OF_SEA + 132,
				TREE_BASE + 203, TOP_OF_SEA + 139, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 200 , TOP_OF_SEA + 130,
				TREE_BASE + 197, TOP_OF_SEA + 139, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 210, TOP_OF_SEA + 133,
				TREE_BASE + 210, TOP_OF_SEA + 148, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 210, TOP_OF_SEA + 137,
				TREE_BASE + 213, TOP_OF_SEA + 144, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 210 , TOP_OF_SEA + 135,
				TREE_BASE + 207, TOP_OF_SEA + 144, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 220, TOP_OF_SEA + 143,
				TREE_BASE + 220, TOP_OF_SEA + 158, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 220, TOP_OF_SEA + 147,
				TREE_BASE + 223, TOP_OF_SEA + 154, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 220 , TOP_OF_SEA + 145,
				TREE_BASE + 217, TOP_OF_SEA + 154, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 230, TOP_OF_SEA + 148,
				TREE_BASE + 230, TOP_OF_SEA + 163, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 230, TOP_OF_SEA + 152,
				TREE_BASE + 233, TOP_OF_SEA + 159, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 230 , TOP_OF_SEA + 150,
				TREE_BASE + 227, TOP_OF_SEA + 159, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 240, TOP_OF_SEA + 153,
				TREE_BASE + 240, TOP_OF_SEA + 168, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 240, TOP_OF_SEA + 157,
				TREE_BASE + 243, TOP_OF_SEA + 164, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 240 , TOP_OF_SEA + 155,
				TREE_BASE + 237, TOP_OF_SEA + 164, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 250, TOP_OF_SEA + 158,
				TREE_BASE + 250, TOP_OF_SEA + 173, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 250, TOP_OF_SEA + 162,
				TREE_BASE + 253, TOP_OF_SEA + 169, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 250 , TOP_OF_SEA + 160,
				TREE_BASE + 247, TOP_OF_SEA + 169, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 260, TOP_OF_SEA + 168,
				TREE_BASE + 260, TOP_OF_SEA + 183, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 260, TOP_OF_SEA + 172,
				TREE_BASE + 263, TOP_OF_SEA + 179, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 260 , TOP_OF_SEA + 170,
				TREE_BASE + 257, TOP_OF_SEA + 179, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 270, TOP_OF_SEA + 173,
				TREE_BASE + 270, TOP_OF_SEA + 188, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 270, TOP_OF_SEA + 177,
				TREE_BASE + 273, TOP_OF_SEA + 184, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 270 , TOP_OF_SEA + 175,
				TREE_BASE + 267, TOP_OF_SEA + 184, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 280, TOP_OF_SEA + 178,
				TREE_BASE + 280, TOP_OF_SEA + 193, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 280, TOP_OF_SEA + 182,
				TREE_BASE + 283, TOP_OF_SEA + 189, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 280 , TOP_OF_SEA + 180,
				TREE_BASE + 277, TOP_OF_SEA + 189, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 290, TOP_OF_SEA + 183,
				TREE_BASE + 290, TOP_OF_SEA + 198, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 290, TOP_OF_SEA + 187,
				TREE_BASE + 293, TOP_OF_SEA + 194, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 290 , TOP_OF_SEA + 185,
				TREE_BASE + 287, TOP_OF_SEA + 194, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 300, TOP_OF_SEA + 193,
				TREE_BASE + 300, TOP_OF_SEA + 208, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 300, TOP_OF_SEA + 197,
				TREE_BASE + 303, TOP_OF_SEA + 204, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 300 , TOP_OF_SEA + 195,
				TREE_BASE + 297, TOP_OF_SEA + 204, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 310, TOP_OF_SEA + 198,
				TREE_BASE + 310, TOP_OF_SEA + 213, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 310, TOP_OF_SEA + 202,
				TREE_BASE + 313, TOP_OF_SEA + 209, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 310 , TOP_OF_SEA + 200,
				TREE_BASE + 307, TOP_OF_SEA + 209, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 320, TOP_OF_SEA + 203,
				TREE_BASE + 320, TOP_OF_SEA + 218, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 320, TOP_OF_SEA + 207,
				TREE_BASE + 323, TOP_OF_SEA + 214, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 320 , TOP_OF_SEA + 205,
				TREE_BASE + 317, TOP_OF_SEA + 214, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 330, TOP_OF_SEA + 213,
				TREE_BASE + 330, TOP_OF_SEA + 228, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 330, TOP_OF_SEA + 217,
				TREE_BASE + 333, TOP_OF_SEA + 224, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 330 , TOP_OF_SEA + 215,
				TREE_BASE + 327, TOP_OF_SEA + 224, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 340, TOP_OF_SEA + 223,
				TREE_BASE + 340, TOP_OF_SEA + 238, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 340, TOP_OF_SEA + 227,
				TREE_BASE + 343, TOP_OF_SEA + 234, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 340 , TOP_OF_SEA + 225,
				TREE_BASE + 337, TOP_OF_SEA + 234, 3);


  GP142_lineXY(FOREST_GREEN, TREE_BASE + 350, TOP_OF_SEA + 228,
				TREE_BASE + 350, TOP_OF_SEA + 243, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 350, TOP_OF_SEA + 232,
				TREE_BASE + 353, TOP_OF_SEA + 239, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 350 , TOP_OF_SEA + 230,
				TREE_BASE + 347, TOP_OF_SEA + 239, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360, TOP_OF_SEA + 233,
				TREE_BASE + 360, TOP_OF_SEA + 248, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360, TOP_OF_SEA + 237,
				TREE_BASE + 363, TOP_OF_SEA + 244, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360 , TOP_OF_SEA + 235,
				TREE_BASE + 357, TOP_OF_SEA + 244, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360, TOP_OF_SEA + 233,
				TREE_BASE + 360, TOP_OF_SEA + 248, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360, TOP_OF_SEA + 237,
				TREE_BASE + 363, TOP_OF_SEA + 244, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 360 , TOP_OF_SEA + 235,
				TREE_BASE + 357, TOP_OF_SEA + 244, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 370, TOP_OF_SEA + 238,
				TREE_BASE + 370, TOP_OF_SEA + 253, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 370, TOP_OF_SEA + 242,
				TREE_BASE + 373, TOP_OF_SEA + 249, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 370 , TOP_OF_SEA + 240,
				TREE_BASE + 367, TOP_OF_SEA + 249, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 380, TOP_OF_SEA + 248,
				TREE_BASE + 380, TOP_OF_SEA + 263, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 380, TOP_OF_SEA + 252,
				TREE_BASE + 383, TOP_OF_SEA + 259, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 380 , TOP_OF_SEA + 250,
				TREE_BASE + 377, TOP_OF_SEA + 259, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 390, TOP_OF_SEA + 253,
				TREE_BASE + 390, TOP_OF_SEA + 268, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 390, TOP_OF_SEA + 257,
				TREE_BASE + 393, TOP_OF_SEA + 264, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 390 , TOP_OF_SEA + 260,
				TREE_BASE + 387, TOP_OF_SEA + 264, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 400, TOP_OF_SEA + 263,
				TREE_BASE + 400, TOP_OF_SEA + 278, 4);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 400, TOP_OF_SEA + 267,
				TREE_BASE + 403, TOP_OF_SEA + 274, 3);

  GP142_lineXY(FOREST_GREEN, TREE_BASE + 400 , TOP_OF_SEA + 270,
				TREE_BASE + 397, TOP_OF_SEA + 274, 3);

  /* Draw the big ship */

  GP142_circleXY(WHITE, ship_x , ship_y, 12);

  GP142_circleXY(BLUE, ship_x + 3, ship_y, 12);

  GP142_circleXY(WHITE, ship_x + 13 , ship_y, 10);

  GP142_circleXY(BLUE, ship_x + 16, ship_y, 10);

  GP142_circleXY(WHITE, ship_x + 20 , ship_y, 10);

  GP142_circleXY(BLUE, ship_x + 23, ship_y, 10);



  GP142_rectangleXY(RED, ship_x, ship_y,
					ship_x + 170, ship_y + 30, FILL);

  GP142_rectangleXY(RED, ship_x - 50, ship_y + 30,
					ship_x + 200, ship_y + 70, FILL);

  GP142_triangleXY(BLUE, ship_x + 125, ship_y,
					ship_x + 175, ship_y,
					ship_x + 175, ship_y + 30, FILL);

  GP142_triangleXY(BLUE, ship_x + 175, -GP142_YMAX + 140,
					ship_x + 210, ship_y + 30,
					ship_x + 210, ship_y + 40, FILL);

  GP142_lineXY(WHITE, ship_x + 130, ship_y, 
				ship_x + 190, ship_y - 3, 1);

   GP142_lineXY(WHITE, ship_x + 130, ship_y + 3, 
				ship_x + 190, ship_y + 3, 1);

  GP142_triangleXY(BLUE, ship_x + 30, ship_y,
					ship_x, ship_y,
					ship_x, ship_y + 30, FILL);

  GP142_triangleXY(BLUE, ship_x, ship_y + 30,
					ship_x - 50, ship_y + 30,
					ship_x - 50, ship_y + 40, FILL);

  GP142_lineXY(BLACK, ship_x, ship_y + 30,
				ship_x + 170, ship_y + 30, 4);

  GP142_rectangleXY(YELLOW, ship_x - 30, ship_y + 70,
					ship_x - 10, ship_y + 100, FILL);

  GP142_rectangleXY(YELLOW, ship_x + 170, ship_y + 70,
					ship_x + 185, ship_y + 110, FILL);

  GP142_rectangleXY(RED, ship_x + 150, ship_y + 70,
					ship_x + 10, ship_y + 100, FILL);
  
  GP142_rectangleXY(RED, ship_x + 10, ship_y + 100,
					ship_x + 70, ship_y + 125, FILL); 

  GP142_rectangleXY(WHITE, ship_x + 10, ship_y + 125,
					ship_x + 70, ship_y + 135, FILL);

  GP142_lineXY(WHITE, ship_x - 10, ship_y + 135,
				ship_x + 70, ship_y + 135, 8);

  GP142_rectangleXY(BLACK, ship_x + 15, ship_y + 100,
					ship_x + 30, ship_y + 120, FILL);

  GP142_rectangleXY(BLACK, ship_x + 40, ship_y + 70,
					ship_x + 55, ship_y + 110, FILL);

  GP142_circleXY(PURPLE, ship_x + 50, ship_y + 90, 2);

  GP142_circleXY(BLACK, ship_x + 80, ship_y + 90, 7);

  GP142_circleXY(BLACK, ship_x + 110, ship_y + 90, 7);

  GP142_circleXY(BLACK, ship_x + 140, ship_y + 90, 7);

  GP142_rectangleXY(DUSTY_PLUM, ship_x + 100, ship_y + 100,
					ship_x + 120, ship_y + 140, FILL);

  GP142_rectangleXY(WHITE, ship_x + 100, ship_y + 140,
					ship_x + 120, ship_y + 150, FILL);

  GP142_rectangleXY(BLACK, ship_x + 100, ship_y + 150,
					ship_x + 120, ship_y + 155, FILL);

  GP142_circleXY(BLACK, ship_x + 110, ship_y + 155, 4);

  GP142_circleXY(BLACK, ship_x + 115, ship_y + 160, 4);

  GP142_circleXY(BLACK, ship_x + 120, ship_y + 163, 3);

  GP142_circleXY(BLACK, ship_x + 125, ship_y + 165, 3);

  GP142_circleXY(BLACK, ship_x + 130, ship_y + 165, 3);
  
  GP142_lineXY(WHITE, ship_x - 50, ship_y + 70,
				ship_x + 200, ship_y + 70, 10);


 

} /*end DrawLandscape */


/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather)
{
  int max_speed = 100;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
	  *current_precip = HAIL;
	break;
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  
  case 5:
	*current_color = YELLOW;
	break;

  case 6:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
	  GP142_printfXY(BLACK, text_offset, i, font_size, "Hail");

 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");
  
  i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "YELLOW");
  else 
	GP142_printfXY(BLACK, text_offset, i, font_size, "YELLOW");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}